// ①HTMLトップ返答処理
void sendTop( AsyncWebServerRequest *request ) {
  // ②返答HTML定義
  char *htmltop = 
  "<!doctype html><html class='fullscrn'><head><meta charset='UTF-8'/>\r\n"
  "<meta name='viewport' content='width=device-width'/>\r\n"
  "<link rel=\"icon\" href=\"http://kit.socinno.com/wp-content/uploads/2019/09/favicon.ico\">\r\n"
  "<style type='text/css'><!--\r\n"
  "h1 { margin: 13px 0; font-size: 28px; line-height: 70%; }\r\n"
  "#contents { width: 100%; max-width: 320px; }\r\n"
  "footer { text-align: right; }\r\n"
  ".fullscrn { width: 100%; height: 100%; }\r\n"
  ".cosmos { color: white; background-color: #797572;\r\n"
  "background-image: linear-gradient(-173deg, rgba(255,255,255,0.20) 0%, #000000 100%),\r\n"
  "linear-gradient(72deg, rgba(255,255,255,0.25) 25%, rgba(0,0,0,0.25) 100%),\r\n"
  "radial-gradient(47% 102%, rgba(255,255,255,0.50) 0%, rgba(21,24,32,0.60) 120%);background-blend-mode: multiply; }\r\n"
  "--></style>\r\n"
  "<title>sLab-Car</title></head>\r\n"
  "<body class='cosmos fullscrn'><center><div id='contents'><header><h3>sLab-Car制御画面</h3></header>\r\n"
  "<form id='canform' method='get' action='javascript:void(0);'>\r\n"
  "\r\n"
  "<div id='dcan1' style=\"display:none\"><canvas id=\"ccanvas\" width=\"176\" height=\"144\" style=\"background-color:grey; float:left\"></canvas>\r\n"
  "<input id='chkCan1' type=\"checkbox\" checked onclick=\"canDisp(0);\">映像表示<br>\r\n"
  "<span style='line-height:25px;text-align:center;'><br><button id='startbtn' type='button' style='width:70px;height:25px' onClick=\"wsConnect()\" >開始</button><br>\r\n"
  "<font color=red><span id=\"msg\" style='vertical-align:middle;'>DISCONNECT</span></font><br>\r\n"
  "<button id='endbtn' type='button' style='width:70px;height:25px' onClick=\"wsDisconnect()\" >終了</button></span><p style=\"clear: both;\"></p><br></div>\r\n"
  "\r\n"
  "<table width=100%><tr><td>カー制御</td><td align=right><span id='dcan2' style=\"display:inline\"><input id='chkCan2' type=\"checkbox\" onclick=\"canDisp(1);\">映像表示</span></td></tr></table>\r\n"
  "<table width=100%><tr><td></td><td><button id='gobtn' type='button' style='width:100px;height:60px' onClick='car_cnt(\"GO\")' >GO</button></td><td></td></tr>\r\n"
  "<tr><td><button id='leftbtn' type='button' style='width:100px;height:60px' onClick='car_turn(\"LEFT\")' >LEFT</button></td>\r\n"
  "<td><button id='stopbtn' type='button' style='width:100px;height:60px' onClick='car_cnt(\"STOP\")' >STOP</button></td>\r\n"
  "<td><button id='rightbtn' type='button' style='width:100px;height:60px' onClick='car_turn(\"RIGHT\")' >RIGHT</button></td></tr>\r\n"
  "<tr><td style='vertical-align:top;'>左<input type=\"text\" id=\"leftms\" size=4 value=250>ms</td>\r\n"
  "<td><button id='backbtn' type='button' style='width:100px;height:60px' onClick='car_cnt(\"BACK\")' >BACK</button></td>\r\n"
  "<td style='vertical-align:top; text-align:right;'>右<input type=\"text\" id=\"rightms\" size=4 value=250>ms</td></tr><table><br>\r\n"
  "\r\n"
  "<table width=100%><tr><td>距離センサー制御</td><td align=right>距離：<span id='distance'>0</span>cm</td></tr></table>\r\n"
  "<table width=100%><tr><td><button id='leftsbtn' type='button' style='width:100px;height:60px' onClick='sen_cnt(\"LEFT\")' >LEFT</button></td>\r\n"
  "<td><button id='centersbtn' type='button' style='width:100px;height:60px' onClick='sen_cnt(\"CENTER\")' >CENTER</button></td>\r\n"
  "<td><button id='rightsbtn' type='button' style='width:100px;height:60px' onClick='sen_cnt(\"RIGHT\")' >RIGHT</button></td></tr>\r\n"
  "<tr><td style='vertical-align:top;'><div style='line-height:0.9em;'>左<input type=\"text\" id=\"leftdo\" size=3 value=180>度<br><br><br>左IR:<span id=\"leftir\">無し</span></div></td>\r\n"
  "<td><button id='measurebtn' type='button' style='width:100px;height:60px' onClick='s_mesure()' >MESUREMENT</button></td>\r\n"
  "<td style='vertical-align:top; text-align:right;'><div style='line-height:0.9em;'>右<input type=\"text\" id=\"rightdo\" size=3 value=0>度<br><br><br>右IR:<span id=\"rightir\">無し</span></div></td></tr><table>\r\n"
  "</form>\r\n"
  "\r\n"
  "<div id='dispStatus'></div>\r\n"
  "\r\n"
  "<script language=\"javascript\" type=\"text/javascript\">\r\n"
  "var wsUri;\r\n"
  "var socket = null;\r\n"
  "var tms;\r\n"
  "var msgIn;\r\n"
  "var msg;\r\n"
  "var ctx;\r\n"
  "var width;\r\n"
  "var height;\r\n"
  "var imageData;\r\n"
  "var pixels;\r\n"
  "var fps = 0;\r\n"
  "var jobFlag = false;\r\n"
  "var canFlag = false;\r\n"
  "var wsFlag = false;\r\n"
  "window.onload = function(){\r\n"
  " wsUri = \"ws://\" + window.location.hostname + \":81/\";\r\n"
  " msgIn = document.getElementById('msgIn');\r\n"
  " msg = document.getElementById('msg');\r\n"
  " var canv = document.getElementById('ccanvas');\r\n"
  " ctx = canv.getContext('2d');\r\n"
  " width = canv.width;\r\n"
  " height = canv.height;\r\n"
  " imageData = ctx.createImageData( width, 1 );\r\n"
  " pixels = imageData.data;\r\n"
  " var fullpath = location.href\r\n"
  " var path = fullpath.split('?');\r\n"
  " if ( path[1] && path[1] != \"\" ) {\r\n"
  "   var eachData = path[1].split('&');\r\n"
  "   for (var i = 0; i < eachData.length; i++) {\r\n"
  "     var tmpData = eachData[i].split('=');\r\n"
  "     if ( tmpData[0] == \"camera\" && tmpData[1] == \"on\" ) {\r\n"
  "       canFlag = true;\r\n"
  "       canDisp(1);\r\n"
  "     } else if ( tmpData[0] == \"rms\" ) {\r\n"
  "       document.getElementById(\"rightms\").value = tmpData[1];\r\n"
  "     } else if ( tmpData[0] == \"lms\" ) {\r\n"
  "       document.getElementById(\"leftms\").value = tmpData[1];\r\n"
  "     } else if ( tmpData[0] == \"rdo\" ) {\r\n"
  "       document.getElementById(\"rightdo\").value = tmpData[1];\r\n"
  "     } else if ( tmpData[0] == \"ldo\" ) {\r\n"
  "       document.getElementById(\"leftdo\").value = tmpData[1];\r\n"
  "     }\r\n"
  "   }\r\n"
  " }\r\n"
  " if (canFlag) {\r\n"
  "   document.getElementById(\"startbtn\").disabled = true;\r\n"
  "   setTimeout('wsConnect()', 1000);\r\n"
  " }\r\n"
  "}\r\n"
  "\r\n"
  "function Msg(message){ msg.innerHTML = message;}\r\n"
  "function wsConnect(){\r\n"
  " wsFlag = true;\r\n"
  " document.getElementById(\"startbtn\").disabled = true;\r\n"
  " tms = new Date();\r\n"
  " if(socket == null){\r\n"
  "   socket = new WebSocket(wsUri);\r\n"
  "   socket.binaryType = 'arraybuffer';\r\n"
  "   socket.onopen   = function(evt){ onOpen(evt) };\r\n"
  "   socket.onclose  = function(evt){ onClose(evt) };\r\n"
  "   socket.onmessage = function(evt){ onMessage(evt) };\r\n"
  "   socket.onerror  = function(evt){ onError(evt) };\r\n"
  " }\r\n"
  "}\r\n"
  "function wsDisconnect(){\r\n"
  " wsFlag = false;\r\n"
  " socket.close();\r\n"
  " socket = null;\r\n"
  " Msg('STOP');\r\n"
  " document.getElementById(\"startbtn\").disabled = false;\r\n"
  "}\r\n"
  "function onOpen(evt){ Msg('START');}\r\n"
  "function onClose(evt){\r\n"
  " Msg('DISCONNECT');\r\n"
  " wsClose();\r\n"
  " document.getElementById(\"startbtn\").disabled = false;\r\n"
  "}\r\n"
  "function onError(evt){\r\n"
  " Msg('Err:' + evt.data);\r\n"
  " document.getElementById(\"startbtn\").disabled = false;\r\n"
  "}\r\n"
  "function onMessage(evt){\r\n"
  " var data = evt.data;\r\n"
  " if( typeof data == 'string'){\r\n"
  "   msgIn.innerHTML = data;\r\n"
  " }else if( data instanceof ArrayBuffer){\r\n"
  "   drawLine(evt.data);\r\n"
  " }else if( data instanceof Blob){\r\n"
  "   Msg('Blob data received');\r\n"
  " }\r\n"
  "}\r\n"
  "function wsClose(){\r\n"
  " socket.close();\r\n"
  " socket = null;\r\n"
  " if (wsFlag) {\r\n"
  "   setTimeout('wsConnect()', 1);\r\n"
  " }\r\n"
  "}\r\n"
  "function drawLine(data){\r\n"
  " var buf = new Uint16Array(data);\r\n"
  " for(var y = 0; y < (buf.length)/width; y+=1){\r\n"
  "   var base = 0;\r\n"
  "   for(var x = 0; x < width; x += 1){\r\n"
  "     var c = x + y * width;\r\n"
  "     pixels[base+0] = (buf[c] & 0xf800) >> 8 | (buf[c] & 0xe000) >> 13;\r\n"
  "     pixels[base+1] = (buf[c] & 0x07e0) >> 3 | (buf[c] & 0x0600) >> 9;\r\n"
  "     pixels[base+2] = (buf[c] & 0x001f) << 3 | (buf[c] & 0x001c) >> 2;\r\n"
  "     pixels[base+3] = 255;\r\n"
  "     base += 4;\r\n"
  "   }\r\n"
  "   ctx.putImageData(imageData, 0, y);\r\n"
  " }\r\n"
  " if(y == height) fps+=1;\r\n"
  "}\r\n"
  "function canDisp(chgFlag) {\r\n"
  " if (chgFlag == 0) {\r\n"
  "    document.getElementById(\"dcan1\").style.display=\"none\";\r\n"
  "    document.getElementById(\"dcan2\").style.display=\"inline\";\r\n"
  " } else {\r\n"
  "    document.getElementById(\"dcan1\").style.display=\"block\";\r\n"
  "    document.getElementById(\"dcan2\").style.display=\"none\";\r\n"
  " }\r\n"
  " document.getElementById(\"chkCan1\").checked = true;\r\n"
  " document.getElementById(\"chkCan2\").checked = false;\r\n"
  "}\r\n"
  "function car_cnt(cntSig) {\r\n"
  " var url = \"http://\" + window.location.hostname + \"/cargo?a=\" + cntSig;\r\n"
  " htmlacs(url);\r\n"
  "}\r\n"
  "function car_turn(cntSig) {\r\n"
  " var rltime;\r\n"
  " if ( cntSig == \"RIGHT\" ) {\r\n"
  "   rltime = document.getElementById(\"rightms\").value;\r\n"
  " } else {\r\n"
  "   rltime = document.getElementById(\"leftms\").value;\r\n"
  " }\r\n"
  " var url = \"http://\" + window.location.hostname + \"/carturn?a=\" + cntSig + \"&n=\" + rltime;\r\n"
  " htmlacs(url);\r\n"
  "}\r\n"
  "function s_mesure() {\r\n"
  " var url = \"http://\" + window.location.hostname + \"/update_d\";\r\n"
  " htmlacs(url);\r\n"
  "}\r\n"
  "function sen_cnt(cntSig) {\r\n"
  " var rldo;\r\n"
  " if ( cntSig == \"RIGHT\" ) {\r\n"
  "   rldo = document.getElementById(\"rightdo\").value;\r\n"
  " } else if ( cntSig == \"CENTER\" ) {\r\n"
  "   rldo = 90;\r\n"
  " } else {\r\n"
  "   rldo = document.getElementById(\"leftdo\").value;\r\n"
  " }\r\n"
  " var url = \"http://\" + window.location.hostname + \"/s_angle?n=\" + rldo;\r\n"
  " htmlacs(url);\r\n"
  "}\r\n"
  "function htmlacs(url) {\r\n"
  " if (jobFlag) {\r\n"
  "   document.getElementById('dispStatus').innerHTML = \"<b><font color=red>処理中です。</font></b>\";\r\n"
  " }\r\n"
  " jobFlag = true;\r\n"
  " var xhr = new XMLHttpRequest();\r\n"
  " if(xhr.timeout !== undefined){\r\n"
  "   xhr.ontimeout = function(e){\r\n"
  "     finishJob( \"<b><font color=red>本体への通信に失敗</font></b>しました。\" )\r\n"
  "   };\r\n"
  "   xhr.timeout = 10000;\r\n"
  " }\r\n"
  " xhr.open(\"GET\", url);\r\n"
  " xhr.send(\"\");\r\n"
  " xhr.addEventListener(\"load\",function(ev){\r\n"
  "   var resStr = xhr.responseText;\r\n"
  "   if ( url.indexOf('update_d') != -1 ) {\r\n"
  "     var pRecv =  JSON.parse(resStr);\r\n"
  "     document.getElementById('distance').innerHTML = pRecv.d;\r\n"
  "     if ( pRecv.r == 'L' ) {\r\n"
  "       document.getElementById('rightir').innerHTML = '検出';\r\n"
  "     } else {\r\n"
  "       document.getElementById('rightir').innerHTML = '無し';\r\n"
  "     }\r\n"
  "     if ( pRecv.l == 'L' ) {\r\n"
  "       document.getElementById('leftir').innerHTML = '検出';\r\n"
  "     } else {\r\n"
  "       document.getElementById('leftir').innerHTML = '無し';\r\n"
  "     }\r\n"
  "     finishJob( \"<b><font color=red>正常完了しました。</font></b>\" );\r\n"
  "   } else if ( resStr == \"OK\" ) {\r\n"
  "     finishJob( \"<b><font color=red>正常完了しました。</font></b>\" );\r\n"
  "   } else {\r\n"
  "     finishJob( \"<b><font color=red>処理失敗です。再実行して下さい。</font></b>\" );\r\n"
  "   }\r\n"
  " });\r\n"
  "}\r\n"
  "function finishJob( dispWord ){\r\n"
  " jobFlag = false;\r\n"
  " document.getElementById('dispStatus').innerHTML = dispWord;\r\n"
  "}\r\n"
  "</script>\r\n"
  "<br><footer><font size=-1>Copyright© SOCINNO All rights reserved.</font></footer></div></center></body></html>\r\n"
  ;

  // ③返答HTML送信
  request->send(200, "text/html", htmltop);
}
